<?php



include("../conexion/conexion.php");

$usuario=$_SESSION["usuario"];

$GLOBALS["verificrcodi"]=0;

if(isset($_POST["delete"])){
    $codigo= trim($_POST["delete"]);
    // echo("REcibido".$codigo);
    $pro=new productos();
    $pro->eliminarProd($codigo);
}

elseif(isset($_POST["producto"])){

$produ=$_POST["producto"];
$bodega=$_POST["bodega"];
$productosCero=0;

$enceros=false;
if(isset($_POST["enceros"])){

    $enceros=$_POST["enceros"];
}
if(isset($_POST["productosCero"])){
$productosCero=$_POST["productosCero"];
}

if(isset($_POST["categoria"])){
    $categoria=$_POST["categoria"];

    


}else{
    $categoria=null;
}

$pro=new productos();

if($categoria !=null){

   $pro->buscarCategoria($categoria,$bodega,$enceros);
}else{

if(isset($_POST["ubicacionB"]))
{
    $ubicacionB=$_POST["ubicacionB"];
    $productosCero=0;
        if(isset($_POST["productosCero"])){
        $productosCero=$_POST["productosCero"];
        }

    if($ubicacionB =="sin" || $ubicacionB =="" ){
        $buspro=$pro->buscarproducto($produ,$bodega,$productosCero,$enceros);
     }else{
         $buspro=$pro->buscarPorUbicacion($bodega,$ubicacionB);
     }
     

}else{
    $productosCero=0;
    if(isset($_POST["productosCero"])){
    $productosCero=$_POST["productosCero"];
    }

   
    
    $buspro=$pro->buscarproducto($produ,$bodega,$productosCero,$enceros);
}



}


}


elseif(isset($_POST["prod"])){

    $produ=$_POST["prod"];
    $bodega=$_POST["bodega"];

    

    $pro=new productos();
    $buspro=$pro->buscarproducodi($produ,$bodega);
    
    
    
    }
//actulizar datos del producto
    elseif(isset($_POST["codigo"])){
        $codigo=$_POST["codigo"];$costoc=str_replace(' ', '',$_POST["costoc"]);
        $nombre=$_POST["nombre"];$costof=str_replace(' ', '',$_POST["costof"]);
        $barras=str_replace(' ', '',$_POST["barras"]);$iva=str_replace(' ', '',$_POST["iva"]);
        $factor=str_replace(' ', '',$_POST["factor"]);$utilcaja=str_replace(' ', '',$_POST["utilcaja"]);
        $inventario=$_POST["inventario"];$utilfrcc=str_replace(' ', '',$_POST["utilfrcc"]);
        $marca=$_POST["marca"];
        $categoria=$_POST["caregoria"];
        $icomision=str_replace(' ', '',$_POST["icomision"]);
        $comision2=str_replace(' ', '',$_POST["comision2"]);
        $pabierto=$_POST["pabierto"];
        $barras2=str_replace(' ', '',$_POST["barras2"]);

        $barras3=str_replace(' ', '',$_POST["barras3"]);

        $ventaCaja=str_replace(' ', '',$_POST["ventaCaja"]);
        $ventaFrcc=str_replace(' ', '',$_POST["ventaFrcc"]);

        $ventaCaja2=str_replace(' ', '',$_POST["ventaCaja2"]);
        $ventaFrcc2=str_replace(' ', '',$_POST["ventaFrcc2"]);
        $bodega=$_POST["bodega"];
        $invimac=$_POST["invimaa"];
        $asignar=$_POST["asignar"];
        $bodegaasignar=$_POST["bodegaasignar"];
        $preciosTodosP=$_POST["preciosTodosP"];
        $tipoproducto=$_POST["tipoproducto"];
        $controlinventarioAc=$_POST["controlinventarioAc"];
        $factorblister=str_replace(' ', '',$_POST["factorblister"]);
        $precioblister=str_replace(' ', '',$_POST["precioblister"]);
        $dte=str_replace(' ', '',$_POST["dte"]);
        $dtemax=str_replace(' ', '',$_POST["dtemax"]);

        $utilidadCaja2=str_replace(' ', '', $_POST["utilidadCaja2"]);
        $utilidadFrcc2=str_replace(' ', '',$_POST["utilidadFrcc2"]);
        $precioCaja3=str_replace(' ', '',$_POST["precioCaja3"]);
        $precioFrcc3=str_replace(' ', '',$_POST["precioFrcc3"]);
        $utilidadCaja3=str_replace(' ', '',$_POST["utilidadCaja3"]);
        $utilidadFrcc3=str_replace(' ', '',$_POST["utilidadFrcc3"]);
        $mensajeProducEdi=$_POST["mensajeProducEdi"];
        $CodigoOBS=$_POST["CodigoOBS"];
        $EdienvioCocina=$_POST["EdienvioCocina"];
        $estadoProduc=$_POST["estadoProduc"];
        


        if(!is_numeric($dte)){
            $dte=0;
        }
        if(!is_numeric($dtemax)){
            $dtemax=0;
        }

        if($tipoproducto==null || $tipoproducto=="" ||$tipoproducto==" "){
            $tipoproducto="General";
        }
        

        $conn=new conexion();
        $conectar=$conn->conectar();

//inicia
if($asignar==1){

    $produ="SELECT * FROM `inventarios` WHERE codigoProd='$codigo' and idbodega=$bodegaasignar";

    $ejecutar=$conectar->query($produ);
    if(  $fila=mysqli_fetch_object($ejecutar)){
        
        echo("El producto ya esta asigando a la bodega");

    }else{

        $inserta="INSERT INTO `inventarios`(`codigoProd`, `costocaja`, `costofrcc`, `costopromediocaja`,
    `inventario`, `utilidacaja`, `utilidafrcc`,`VentaCaja`, `VentaFrcc`, `VentaCaja2`, 
    `VentaFrcc2`,`precioblister`,`idbodega`,`utilidacaja2`, `utilidafrcc2`, `VentaCaja3`, `VentaFrcc3`, `utilidacaja3`, `utilidafrcc3`,`ultmaModificacion`)
    VALUES ('$codigo',$costoc,$costof,0,0,'$utilcaja','$utilfrcc',
    '$ventaCaja','$ventaFrcc','$ventaCaja2',
    '$ventaFrcc2','$precioblister',$bodegaasignar,'$utilidadCaja2','$utilidadFrcc2','$precioCaja3','$precioFrcc3','$utilidadCaja3','$utilidadFrcc3','$usuario')";



$ejecutar=$conectar->query($inserta);





        if($ejecutar){
            echo("El producto fue asignado con exito");  
        }else{
            echo( "Error al  asignado Producto, verifica costos y valores"); 
        }

    }


}else{

    $actuli=$conectar->query("UPDATE `productos`  SET `CostoCajaP`='$costoc',
    `CostoFrccP`='$costof',
    `VentaCajaP`='$ventaCaja',`VentaFrccP`='$ventaFrcc',`UtilidadCajaP`='$utilcaja',`UtilidadFrccP`='$utilfrcc',
    `PrecioBlisterCaja`='$precioblister',`DeCocina`='$EdienvioCocina', `ACTIVO`=$estadoProduc, `ComisionP2`='$comision2' WHERE codigo='$codigo' ");


       if($marca==""&& $categoria==""){
   
        
        $productos="UPDATE `productos` SET `nombre`='$nombre',
        `barras`='$barras',`barras2`='$barras2',`barras3`='$barras3',
        `factor`='$factor',`impuesto`='$iva',`ComisionP`= '$icomision',
        `registroInvima`='$invimac', `tipoProducto`='$tipoproducto',
        `factorblister`='$factorblister',
        `MensajePromo`='$mensajeProducEdi',`CodigoOBS`='$CodigoOBS'  WHERE codigo='$codigo'";
        $ejecutar=$conectar->query($productos);
        
       
        
        $actuli0="UPDATE `inventarios` SET `costocaja`='$costoc',`costofrcc`='$costof',
        `utilidacaja`='$utilcaja', `utilidafrcc`='$utilfrcc',`pabierto`='$pabierto',`VentaCaja`='$ventaCaja',`VentaFrcc`='$ventaFrcc',`VentaCaja2`='$ventaCaja2',
        `VentaFrcc2`='$ventaFrcc2',`controlInventario`='$controlinventarioAc',`precioblister`='$precioblister',`descuentoPor`='$dte',`dteMax`='$dtemax',
        `utilidacaja2`='$utilidadCaja2', `utilidafrcc2`='$utilidadFrcc2', `VentaCaja3`='$precioCaja3', 
        `VentaFrcc3`='$precioFrcc3', `utilidacaja3`='$utilidadCaja3',
         `utilidafrcc3`='$utilidadFrcc3',`ultmaModificacion`='$usuario'  WHERE idbodega=$bodega  and  codigoProd='$codigo'";
        
        $ejecutar=$conectar->query($actuli0);


      

       }else{      
         if($marca!=""&& $categoria!=""){
            $marcate=new productos();
            $busmarca=$marcate->consultarmarca($marca);
            $buscatego=$marcate->consulcategoria($categoria);

            $productos="UPDATE `productos` SET `nombre`='$nombre',`barras`='$barras',`barras2`='$barras2',`barras3`='$barras3',`factor`='$factor',`impuesto`='$iva',`codmarca`='$busmarca',`codcategoria`='$buscatego',`ComisionP`= '$icomision',`registroInvima`= '$invimac',`tipoProducto`='$tipoproducto', `factorblister`='$factorblister',`MensajePromo`='$mensajeProducEdi'  WHERE codigo='$codigo'";
            $ejecutar=$conectar->query($productos);


       
        
        $actuli="UPDATE `inventarios` SET `costocaja`='$costoc',`costofrcc`='$costof',
        `utilidacaja`='$utilcaja', `utilidafrcc`='$utilfrcc',`pabierto`='$pabierto',`VentaCaja`='$ventaCaja',`VentaFrcc`='$ventaFrcc',`VentaCaja2`='$ventaCaja2',
        `VentaFrcc2`='$ventaFrcc2',`controlInventario`='$controlinventarioAc',`precioblister`='$precioblister',`descuentoPor`='$dte',`dteMax`='$dtemax',`utilidacaja2`='$utilidadCaja2', `utilidafrcc2`='$utilidadFrcc2', `VentaCaja3`='$precioCaja3', 
        `VentaFrcc3`='$precioFrcc3', `utilidacaja3`='$utilidadCaja3',
         `utilidafrcc3`='$utilidadFrcc3',`ultmaModificacion`='$usuario'  WHERE idbodega=$bodega and  codigoProd='$codigo'";
        
        
        $ejecutar=$conectar->query($actuli);
         }else{

            if($marca==""&& $categoria!=""){
                $marcate=new productos();
               
                $buscatego=$marcate->consulcategoria($categoria);

                $productos="UPDATE `productos` SET `nombre`='$nombre',
                `barras`='$barras',`barras2`='$barras2',`barras3`='$barras3',
                `factor`='$factor',`impuesto`='$iva',`codcategoria`='$buscatego',
                `ComisionP`= '$icomision',`registroInvima`= '$invimac',
                `tipoProducto`='$tipoproducto',
                 `factorblister`='$factorblister',
                 `MensajePromo`='$mensajeProducEdi'  WHERE codigo='$codigo'";

                $ejecutar=$conectar->query($productos);


                $actuli="UPDATE `inventarios` SET `costocaja`='$costoc',`costofrcc`='$costof',
                `utilidacaja`='$utilcaja', `utilidafrcc`='$utilfrcc',`pabierto`='$pabierto',`VentaCaja`='$ventaCaja',`VentaFrcc`='$ventaFrcc',`VentaCaja2`='$ventaCaja2',
                `VentaFrcc2`='$ventaFrcc2',`controlInventario`='$controlinventarioAc',`precioblister`='$precioblister',`descuentoPor`='$dte',`dteMax`='$dtemax',`utilidacaja2`='$utilidadCaja2', `utilidafrcc2`='$utilidadFrcc2', `VentaCaja3`='$precioCaja3', 
        `VentaFrcc3`='$precioFrcc3', `utilidacaja3`='$utilidadCaja3',
         `utilidafrcc3`='$utilidadFrcc3',`ultmaModificacion`='$usuario'  WHERE idbodega=$bodega and  codigoProd='$codigo'";

                
                  $ejecutar=$conectar->query($actuli);

            }else{

                if($marca!=""&& $categoria==""){
                    $marcate=new productos();
                    $busmarca=$marcate->consultarmarca($marca);


                    $productos="UPDATE `productos` SET `nombre`='$nombre',`barras`='$barras',`barras2`='$barras2',`barras3`='$barras3',`factor`='$factor',`impuesto`='$iva',`codmarca`='$busmarca',`ComisionP`= '$icomision',`registroInvima`= '$invimac',`tipoProducto`='$tipoproducto', `factorblister`='$factorblister',`MensajePromo`='$mensajeProducEdi'  WHERE codigo='$codigo'";
                    $ejecutar=$conectar->query($productos);
                    
                    $actuli="UPDATE `inventarios` SET `costocaja`=$costoc,`costofrcc`=$costof,
                    `utilidacaja`='$utilcaja', `utilidafrcc`='$utilfrcc',`pabierto`='$pabierto',`VentaCaja`='$ventaCaja',`VentaFrcc`='$ventaFrcc',`VentaCaja2`='$ventaCaja2',
                    `VentaFrcc2`='$ventaFrcc2',`controlInventario`='$controlinventarioAc',`precioblister`='$precioblister',`descuentoPor`='$dte',`dteMax`='$dtemax',`utilidacaja2`='$utilidadCaja2', `utilidafrcc2`='$utilidadFrcc2', `VentaCaja3`='$precioCaja3', 
        `VentaFrcc3`='$precioFrcc3', `utilidacaja3`='$utilidadCaja3',
         `utilidafrcc3`='$utilidadFrcc3',`ultmaModificacion`='$usuario'  WHERE idbodega=$bodega and  codigoProd='$codigo'";
                   $ejecutar=$conectar->query($actuli);
                }
            }
         }
        
      






        }
        if($preciosTodosP=="si"){

            $actuli="UPDATE `inventarios` SET 
            `utilidacaja`='$utilcaja', `utilidafrcc`='$utilfrcc',`VentaCaja`='$ventaCaja',`VentaFrcc`='$ventaFrcc',`VentaCaja2`='$ventaCaja2',
            `VentaFrcc2`='$ventaFrcc2',`precioblister`='$precioblister',`utilidacaja2`='$utilidadCaja2', `utilidafrcc2`='$utilidadFrcc2', `VentaCaja3`='$precioCaja3', 
        `VentaFrcc3`='$precioFrcc3', `utilidacaja3`='$utilidadCaja3',
         `utilidafrcc3`='$utilidadFrcc3',`descuentoPor`='$dte',`dteMax`='$dtemax',`ultmaModificacion`='$usuario'  WHERE codigoProd='$codigo'";
           $ejecutar=$conectar->query($actuli);
           

         }
        if($ejecutar){
            echo("Producto actulizado con exito");
        }else{
            echo("error al actulizar producto");
        }
    }
        //finaliza actulizar producto

    }
//crear producto nuevo

    elseif(isset($_POST["cod"])){
        $codigo=str_replace(' ', '',$_POST["cod"]);$costoc=str_replace(' ', '',$_POST["costoc"]);
        $nombre=$_POST["nombre"];$costof=str_replace(' ', '',$_POST["costof"]);
        $barras=$_POST["barras"];$iva=str_replace(' ', '',$_POST["iva"]);
        $factor=str_replace(' ', '',$_POST["factor"]);$utilcaja=str_replace(' ', '',$_POST["utilcaja"]);
        $utilfrcc=str_replace(' ', '',$_POST["utilfrcc"]);

        $marca=$_POST["marca"];
        $categoria=$_POST["caregoria"];
        
        $comisionn=str_replace(' ', '',$_POST["comision"]);
$comisionn2=str_replace(' ', '',$_POST["comision2"]);


        
        $barras2=str_replace(' ', '',$_POST["barras2"]);
        $barras3=str_replace(' ', '',$_POST["barras3"]);
        $ubicacion1=$_POST["ubicacion1"];
        $ubicacion2=$_POST["ubicacion2"];

        $ventaCaja=str_replace(' ', '',$_POST["ventaCaja"]);
        $ventaFrcc=str_replace(' ', '',$_POST["ventaFrcc"]);

        $ventaCaja2=str_replace(' ', '',$_POST["ventaCaja2"]);
        $ventaFrcc2=str_replace(' ', '',$_POST["ventaFrcc2"]);
        $invima=$_POST["invima"];

        $tipoproductoCre=$_POST["tipoproductoCre"];
        $controlinventario=$_POST["controlinventario"];

        $factorblister=str_replace(' ', '',$_POST["factorblister"]);
        $precioblister=str_replace(' ', '',$_POST["precioblister"]);

        $dte=str_replace(' ', '',$_POST["dte"]);
        $dtemax=str_replace(' ', '',$_POST["dtemax"]);

        $utilidadCaja2=str_replace(' ', '', $_POST["utilidadCaja2"]);
        $utilidadFrcc2=str_replace(' ', '',$_POST["utilidadFrcc2"]);
        $precioCaja3=str_replace(' ', '',$_POST["precioCaja3"]);
        $precioFrcc3=str_replace(' ', '',$_POST["precioFrcc3"]);
        $utilidadCaja3=str_replace(' ', '',$_POST["utilidadCaja3"]);
        $utilidadFrcc3=str_replace(' ', '',$_POST["utilidadFrcc3"]);
        $mensajeProd=$_POST["mensajeProd"];
        $crearCocina=$_POST["crearCocina"];

         if(!is_numeric($precioCaja3)){
            $precioCaja3=0;
        }
        if(!is_numeric($precioFrcc3)){
            $precioFrcc3=0;
        }
       
         // precioblister
        // factorblister
        if(!is_numeric($dte)){
            $dte=0;
        }
        if(!is_numeric($dtemax)){
            $dtemax=0;
        }

        if(!is_numeric($factorblister)){
            $factorblister=0;
        }
        if(!is_numeric($precioblister)){
            $precioblister=0;
        }
       

        $costopromediocaja=0;
        // $bodega=$_POST["bodega"];

        if($tipoproductoCre==null || $tipoproductoCre=="" || $tipoproductoCre==" "){
            $tipoproductoCre="General";
        }

         //anexar german
         if(!is_numeric($costoc)){
            $costoc=0;
        }

        if(!is_numeric($costof)){
            $costof=0;
        }
        if(!is_numeric($ventaCaja2)){
            $ventaCaja2=0;
        }
        if(!is_numeric($ventaCaja)){
            $ventaCaja=0;
        }
       
        if(!is_numeric($ventaFrcc)){
            $ventaFrcc=0;
        }
        if(!is_numeric( $ventaFrcc2)){
            $ventaFrcc2=0;
        }
        if(!is_numeric( $comisionn)){
            $comisionn=0;
        }
        if(!is_numeric($iva)){
            $iva=0;
        }

        if(!is_numeric($factor)){
            $factor=0;
        }
              
//fin anexar german

     if($codigo!=""){
        $marcate=new productos();
        $valorbus=$marcate->validarproducodi($codigo);
        if($GLOBALS["verificrcodi"]==1){
            echo("el producto ya existe, no se purde crear");
        }else{
        


        if($marca==""|| $categoria==""){
            echo("NO HA SELECIONADO UNA MARCA O CATEGORIA");

        }else{


                        $marcate=new productos();
                        $busmarca=$marcate->consultarmarca($marca);
                        $buscatego=$marcate->consulcategoria($categoria);
                      if($busmarca==""|| $buscatego=="" ){

                         echo("LA MARCA O CATEGORIA SELECIONADA NO EXISTE"); 

                      } 
                       else{
                            $conn=new conexion();
                            $conectar=$conn->conectar();
                            $inventario=0;
                            //insertar productos
                            
                            $fechaCre= date("Y-m-d H:i:s");
                           

                            $ejecutar=$conectar->prepare("INSERT INTO `productos`(`codigo`, `nombre`, `barras`, `barras2`,`barras3`, `factor`, `impuesto`, `codmarca`, `codcategoria`,`ComisionP`,`registroInvima`,`tipoProducto`,`factorblister`,`MensajePromo`,`FechaCreacioP`,`DeCocina`, `ComisionP2` ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                            $ejecutar->bind_param("sssssssssssssssss",$codigo,$nombre,$barras,$barras2,$barras3,$factor,$iva,$busmarca,$buscatego,$comisionn,$invima, $tipoproductoCre,$factorblister,$mensajeProd,$fechaCre,$crearCocina,$comisionn2);
                            $ejecutar->execute(); 
                            if($ejecutar){

                                $actuli=$conectar->query("UPDATE `productos`  SET `CostoCajaP`='$costoc',
                                `CostoFrccP`='$costof',
                                `VentaCajaP`='$ventaCaja',`VentaFrccP`='$ventaFrcc',`UtilidadCajaP`='$utilcaja',`UtilidadFrccP`='$utilfrcc',
                                `PrecioBlisterCaja`='$precioblister' WHERE codigo='$codigo' ");

                                $bodegas="SELECT * FROM `bodegas`";
                                $resulBodegas= $conectar->query($bodegas);


                                foreach ($resulBodegas as $key => $value) {
                                    $bodegaa=$value["id"];
                                   
                                   
                                     $ejecutar=$conectar->prepare("INSERT INTO `inventarios`(`codigoProd`, `costocaja`,
                                      `costofrcc`, `costopromediocaja`, `inventario`, `utilidacaja`, `utilidafrcc`,`ubicacion1`,
                                       `ubicacion2`, `VentaCaja`, `VentaFrcc`, `VentaCaja2`, `VentaFrcc2`, `idbodega`,
                                       `controlInventario`,`precioblister`,
                                       `descuentoPor`,`dteMax`,`utilidacaja2`, `utilidafrcc2`, `VentaCaja3`, `VentaFrcc3`, `utilidacaja3`, `utilidafrcc3`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                                     $ejecutar->bind_param("ssssssssssssssssssssssss",$codigo,$costoc,$costof,$costopromediocaja,
                                     $inventario,$utilcaja,$utilfrcc,$ubicacion1,$ubicacion2,
                                     $ventaCaja,$ventaFrcc,$ventaCaja2,$ventaFrcc2,$bodegaa,
                                     $controlinventario,$precioblister,$dte,$dtemax,$utilidadCaja2,$utilidadFrcc2,$precioCaja3,$precioFrcc3,$utilidadCaja3,$utilidadFrcc3);
                                     $ejecutar->execute(); 

                                    

                                }
                                echo("PRODUCTO CREADO CON EXITO");


                             }else{
                                echo("NO SE PUDO CREAR EL PRODUCTO VERIFIQUE NUEVAMENTE");

                             }



                 
                        }

        }}

    }else{
        echo("Datos imcompletos para crear producto");

    }
    }
    

class productos {

    function __construct()
    {
        $conn=new conexion();
        $this->conectar=$conn->conectar();
        
    
    }

    public function eliminarProd($id){

          $consulta="SELECT * FROM `kardex` WHERE producto='$id' LIMIT 1";     
           
        
        $resultado=$this->conectar->query($consulta);
        $fila=$resultado->fetch_all(MYSQLI_ASSOC);
        if( count($fila)>0){
           echo json_encode(["estado"=>"no","mensaje"=>"El  producto No se puede Eliminar,tiene movimientos"]);
        }else{
            $borrarInven="DELETE FROM `inventarios` WHERE codigoProd='$id'";
            $resultado1=$this->conectar->query($borrarInven);
            if ($resultado1 === true) {
                $borrarProd="DELETE FROM `productos` WHERE codigo='$id'";
                $resultado2=$this->conectar->query($borrarProd);

               
                echo json_encode(["estado"=>"ok","mensaje"=>"Producto Borrado Con exito"]);
            } else {
                echo json_encode(["estado"=>"no","mensaje"=>"Hubo un error al ejecutar la el borrado:"]);
                
            }
        }
    }

    public function buscarPorUbicacion($bodega,$ubicacionB){
        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
        
             LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega          

        where (ubicacion1='$ubicacionB' or ubicacion2='$ubicacionB')  AND idbodega=$bodega";
    $resultado=$this->conectar->query($consulta);
            
    $fila=$resultado->fetch_all(MYSQLI_ASSOC);

    echo utf8_encode((json_encode($fila))); 
}
public function buscarCategoria($categoria,$bodega,$enceros=false){

    if($bodega=="0"){
 if( $enceros==false ||  $enceros=="false"){
        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 



        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd
            LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega           
         where  productos.codcategoria='$categoria' and (inventario > 0 or controlInventario='no')";
 }else{
  $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 



        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd
            LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega           
         where  productos.codcategoria='$categoria'";


 }


    }else{

        if( $enceros==false ||  $enceros=="false"){
        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 
          
        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
            LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega        

        where  idbodega=$bodega and productos.codcategoria='$categoria' and (inventario > 0 or controlInventario='no')";
        }else{

    $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 
          
        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
            LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega        

        where  idbodega=$bodega and productos.codcategoria='$categoria'";



        }
    }
    

    $resultado=$this->conectar->query($consulta);

    $fila=$resultado->fetch_all(MYSQLI_ASSOC);

    echo utf8_encode((json_encode($fila))); 
}

//buscar por nombre, devuelve array
    public function buscarproducto($id,$bodega,$productosCero=0, $enceros=false){

       // $consulta="SELECT * FROM `productos` where nombre like '%$id%'";    

       if($id==""){
                 
                if($bodega=="0"){
                    if($productosCero==0){
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 
                    
                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                            LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega             
                        where (inventario>0 or controlInventario='no') ";
                    }else{
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                    INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                     LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                     ";
                    }
                    
                }else{
                    if($productosCero==0){
                    $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                    INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                    
                        LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega         
                    
                    
                    where (inventario>0 or controlInventario='no') AND idbodega=$bodega";
                    }else{
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                        
                            LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega          
                        
                        where  idbodega=$bodega";

                    }
            
            }
                
            
                $resultado=$this->conectar->query($consulta);
            
                $fila=$resultado->fetch_all(MYSQLI_ASSOC);
            
                echo utf8_encode((json_encode($fila))); 
        
       
       }else{

        // if($bodega=="0"){
                    
        // }else{

        // }
                
  
                if($bodega=="0"){

                    if( $enceros==false ||  $enceros=="false"){
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 
                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria  INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                                    
                        LEFT JOIN listaprecio 
                        ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega

                        where nombre like '%$id%' and (inventario > 0 or controlInventario='no')  ORDER BY nombre ASC";  

                    }else{

                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 
                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria  INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                                    
                        LEFT JOIN listaprecio 
                        ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega

                        where nombre like '%$id%'  ORDER BY nombre ASC"; 


                    }





                }else{
                     if( $enceros==false ||  $enceros=="false"){
                        
                    $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                    INNER JOIN categoria on productos.codcategoria=categoria.codcategoria  INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                     LEFT JOIN listaprecio 
                      ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
            
                    
                    where nombre like '%$id%' AND idbodega=$bodega  and (inventario > 0 or controlInventario='no') ORDER BY nombre ASC";  

                     }else{

                    $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                    INNER JOIN categoria on productos.codcategoria=categoria.codcategoria  INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                     LEFT JOIN listaprecio 
                      ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
            
                    
                    where nombre like '%$id%' AND idbodega=$bodega ORDER BY nombre ASC";  

                     }
                }
                 
                $resultado=$this->conectar->query($consulta);
                $fila=$resultado->fetch_all(MYSQLI_ASSOC);

                if(!empty( $fila)){
                    echo utf8_encode((json_encode($fila))); 
           

                }else{

                    if($bodega=="0"){
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                             LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega    
                        
                        where barras='$id'  ";   
                    }else{
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 


                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                        
                              LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega  

                        where   barras='$id' AND idbodega=$bodega "; 
                        }

                
                $resultado=$this->conectar->query($consulta);
                $fila1=$resultado->fetch_all(MYSQLI_ASSOC);
            
                if(!empty($fila1)) {
                    echo  utf8_encode((json_encode($fila1))); 
                    
                }else{

                    if($bodega=="0"){
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                           LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega   
                        
                        where barras2='$id' or  barras3='$id'";               
                     }else{
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                        
                         LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega

                        where (barras2='$id' or  barras3='$id') AND idbodega=$bodega ";          
                    }

                      
                    $resultado=$this->conectar->query($consulta);
                    $fila1=$resultado->fetch_all(MYSQLI_ASSOC);
            
                if(!empty($fila1)) {
                    echo utf8_encode((json_encode($fila1))); 
                    
                }else{
                     if($bodega=="0"){
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd
                         LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega

                         where codigo='$id'";  
                    }else{
                        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 

                            LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega

                        where codigo='$id' AND idbodega=$bodega";
                    }
                      
                    $resultado=$this->conectar->query($consulta);
                    $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
                    

                    //no esta asinado a una bodega
                    if(!empty($fila2)) {
                        echo utf8_encode( (json_encode($fila2)));
                        
                    }else{
                        
                            $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                            INNER JOIN categoria on productos.codcategoria=categoria.codcategoria 
         LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                            
                             where codigo='$id'";  
                       
                             
                           
                        $resultado=$this->conectar->query($consulta);
                        $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
                        
                        if(!empty($fila2)) {
                            echo utf8_encode( (json_encode($fila2)));
                            
                        }else{

                            $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                            INNER JOIN categoria on productos.codcategoria=categoria.codcategoria  
   
                             LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                            
                            where nombre like '%$id%' ORDER BY nombre ASC";  
                       
                             
                           
                            $resultado=$this->conectar->query($consulta);
                            $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
                            if(!empty($fila2)) {
                                echo utf8_encode( (json_encode($fila2)));
                                
                            }else{

                                $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                                INNER JOIN categoria on productos.codcategoria=categoria.codcategoria  
                                LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                                
                                where  barras='$id'";  
                           
                               
                               
                                $resultado=$this->conectar->query($consulta);
                                $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
                                if(!empty($fila2)) {
                                    echo utf8_encode( (json_encode($fila2)));
                                    
                                }else{

                                    $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                                    INNER JOIN categoria on productos.codcategoria=categoria.codcategoria 
                                    
                                LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                                     where  barras2='$id' or  barras3='$id'";  
                               
                                   
                                   
                                    $resultado=$this->conectar->query($consulta);
                                    $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
                                    if(!empty($fila2)) {
                                        echo utf8_encode( (json_encode($fila2)));
                                        
                                    }
        
        
                                }
    
    
    
                            }


                        }
                      
    
    
    
    
                    }




                }
                }
             
        }
        
          
    }




}


// buscar por codigo 

public function buscarproducodi($id,$bodega){

  


    if($bodega=="0"){       
    $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

    INNER JOIN categoria on productos.codcategoria=categoria.codcategoria
       LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega            
    
     where codigo ='$id'";
    }else{
        $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

        INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 

               LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega      

        where codigo='$id' AND idbodega=$bodega";
    }

        
    $resultado=$this->conectar->query($consulta);

    if(  $fila=mysqli_fetch_object($resultado)){
        echo utf8_encode((json_encode($fila)));
        $GLOBALS["verificrcodi"]=1;

    }else{

        
                
        if($bodega=="0"){
            $consulta="SELECT * FROM `productos` where barras ='$id'";     
                  
        }else{
            $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

            INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                          
             LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
            where barras ='$id' AND idbodega=$bodega";     
           
        }
        $resultado=$this->conectar->query($consulta);
    
        if(  $fila=mysqli_fetch_object($resultado)){
            echo utf8_encode((json_encode($fila)));
        }else{
             if($bodega=="0"){
                $consulta="SELECT * FROM `productos` where barras2 ='$id'";            
                    
                }else{

                    $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                    INNER JOIN categoria on productos.codcategoria=categoria.codcategoria INNER JOIN inventarios on productos.codigo=inventarios.codigoProd 
                     LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                                 
                    where (barras2 ='$id' or  barras3='$id') AND idbodega=$bodega ";   

                }   
             $resultado=$this->conectar->query($consulta);
    
        if(  $fila=mysqli_fetch_object($resultado)){
            echo utf8_encode((json_encode($fila)));
        }else{

            $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

            INNER JOIN categoria on productos.codcategoria=categoria.codcategoria  
                LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega        
            
            where codigo='$id'";  
       
             
           
        $resultado=$this->conectar->query($consulta);
        $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
        
        if(!empty($fila2)) {
            echo utf8_encode( (json_encode($fila2)));
            
        }else{

            $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                INNER JOIN categoria on productos.codcategoria=categoria.codcategoria 
                    LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                 where  barras='$id'";   
       
             
           
            $resultado=$this->conectar->query($consulta);
            $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
            if(!empty($fila2)) {
                echo utf8_encode( (json_encode($fila2)));
                
            }else{

                $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 

                INNER JOIN categoria on productos.codcategoria=categoria.codcategoria 
                
                    LEFT JOIN listaprecio 
           ON  productos.codigo= listaprecio.codeProduL  AND listaprecio.BodegaL = $bodega
                          
                 where  barras2='$id' or  barras3='$id'";  
           
       
               
                $resultado=$this->conectar->query($consulta);
                $fila2=$resultado->fetch_all(MYSQLI_ASSOC);
                if(!empty($fila2)) {
                    echo utf8_encode( (json_encode($fila2)));
                    
                }else{
                
                                    
                        $fila=(["nombre"=>"","costocaja"=>"","costofrcc">=""]);
                         echo utf8_encode((json_encode($fila)));
                    


                }



            }


        }





        }
        }
      

    }
  

    


}
public function validarproducodi($id){

    // $consulta="SELECT * FROM `productos` INNER JOIN marca on productos.codmarca=marca.codmarca 
    // INNER JOIN categoria on productos.codcategoria=categoria.codcategoria 
    
    
    // where codigo = '$id'"    ;     
    // $resultado=$this->conectar->query($consulta);

    // if(  $fila=mysqli_fetch_object($resultado)){        
    //     $GLOBALS["verificrcodi"]=1;
    // }

$consulta = "SELECT * FROM productos 
    INNER JOIN marca ON productos.codmarca = marca.codmarca 
    INNER JOIN categoria ON productos.codcategoria = categoria.codcategoria 
    WHERE codigo = '$id' 
       OR barras = '$id' 
       OR barras2 = '$id' 
       OR barras3 = '$id'";

$resultado = $this->conectar->query($consulta);

if ($fila = mysqli_fetch_object($resultado)) {
    $GLOBALS["verificrcodi"] = 1;
}



}     



public function consultarmarca($marca){


   $consulta= "SELECT * FROM `marca` WHERE nommarca='$marca'";
   $ejecutar= $this->conectar->query($consulta);
    $resultado=mysqli_fetch_object($ejecutar);

     $resul=$resultado->codmarca;
return $resul;

}

public function consulcategoria($cate){


    $consulta= "SELECT * FROM `categoria` WHERE nomcategoria='$cate'";
    $ejecutar= $this->conectar->query($consulta);
     $resultado=mysqli_fetch_object($ejecutar);
 
      $resul=$resultado->codcategoria;
 return $resul;
 
 }


 





}



?>